Option Strict On
Imports Microsoft.VisualBasic.Interaction
Module Module1
  Private WithEvents anEmployee As EmployeeWithEvents
  Sub Main()
    Dim Tom As New EmployeeWithEvents("Tom", 100000)
    anEmployee = Tom
    Console.WriteLine(Tom.TheName & "  has salary " & Tom.Salary)
    anEmployee.RaiseSalary(0.2D) 'D necessary for decimal
    Console.WriteLine(Tom.TheName & " still has salary " & Tom.Salary)
    Console.WriteLine("Please press the Enter key")
    Console.ReadLine()
  End Sub

  Public Sub anEmployee_SalarySecurityEvent(ByVal Sender As EmployeeWithEvents, ByVal e As System.EventArgs) Handles anEmployee.SalarySecurityEvent
    MsgBox(Sender.TheName & " had an improper salary raise attempted")
  End Sub
End Module


Public Class EmployeeWithEvents
  Private m_Name As String
  Private m_Salary As Decimal
  Private Const LIMIT As Decimal = 0.1D
  Public Event SalarySecurityEvent(ByVal Sender As EmployeeWithEvents, _
     ByVal e As EventArgs)
  Public Sub New(ByVal sName As String, ByVal curSalary As Decimal)
    m_Name = sName
    m_Salary = curSalary
  End Sub
  ReadOnly Property TheName() As String
    Get
      Return m_Name
    End Get
  End Property
  ReadOnly Property Salary() As Decimal
    Get
      Return m_Salary
    End Get
  End Property
  Public Overloads Sub RaiseSalary(ByVal Percent As Decimal)
    If Percent > LIMIT Then
      'not allowed
      RaiseEvent SalarySecurityEvent(Me, New System.EventArgs())
    Else
      m_Salary = (1 + Percent) * m_Salary
    End If
  End Sub
  Public Overloads Sub RaiseSalary(ByVal Percent As Decimal, _
    ByVal Password As String)
    If Password = "special" Then
      m_Salary = (1 + Percent) * m_Salary
    End If
  End Sub
End Class

