﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PaxScript.Net;

namespace EventHandlers
{
    public partial class Form1 : Form
    {
        private PaxScript.Net.PaxScripter scripter;

        public Form1()
        {
            InitializeComponent();
            scripter = new PaxScript.Net.PaxScripter(this.components);
        }

        private void button1_Click(object sender, EventArgs e)
        {
			scripter.Reset();

			scripter.RegisterType(typeof(Form));
			scripter.RegisterType(typeof(Button));
			scripter.RegisterType(typeof(MessageBox));

			scripter.AddModule("1");

			scripter.AddCode("1", @"using System.Windows.Forms;");

			scripter.AddCode("1", @"public class TestClass");
			scripter.AddCode("1", @"{");
			scripter.AddCode("1", @"public static void OnClickHandler(object sender, EventArgs e)");
			scripter.AddCode("1", @"{");
			scripter.AddCode("1", @"MessageBox.Show(sender.ToString());");
			scripter.AddCode("1", @"MessageBox.Show(e.ToString());");
			scripter.AddCode("1", @"}");
			scripter.AddCode("1", @"}");

			scripter.AddCode("1", @"Form f = new Form();");
			scripter.AddCode("1", @"f.Text = ""Script-defined application"";");
			scripter.AddCode("1", @"Button b = new Button();");
			scripter.AddCode("1", @"b.Text = ""Click me"";");
			scripter.AddCode("1", @"b.Click += new EventHandler(TestClass.OnClickHandler);");

			scripter.AddCode("1", @"f.Controls.Add(b);");

			scripter.AddCode("1", @"f.ShowDialog();");

			scripter.Run(RunMode.Run);
			if (scripter.HasErrors)
				MessageBox.Show(scripter.Error_List[0].Message);

		}
    }
}
