﻿using System;
using System.Collections.Generic;
using PaxScript.Net;

public class AClass1
{
    public void Hello()
    {
        Console.WriteLine("Hello 1");
    }
}


namespace Generic2
{
    public class AClass2
    {
        public void Hello()
        {
            Console.WriteLine("Hello 2");
        }
    }

    class Program
    {
        public class AClass3
        {
            public void Hello()
            {
                Console.WriteLine("Hello 3");
            }
        }

        static void Main(string[] args)
        {
            PaxScripter scripter = new PaxScripter(null);
            scripter.RegisterType(typeof(Dictionary<string, AClass1>));
            scripter.RegisterType(typeof(Dictionary<string, AClass2>));
            scripter.RegisterType(typeof(Dictionary<string, AClass3>));

            scripter.AddModule("1");

            scripter.AddCodeLine("1", @"Dictionary<string, AClass1> dictTest1 = new Dictionary<string, AClass1>();");
            scripter.AddCodeLine("1", @"dictTest1.Add(""test"", new AClass1());");
            scripter.AddCodeLine("1", @"AClass1 X = dictTest1[""test""];");
            scripter.AddCodeLine("1", @"X.Hello();");

            scripter.AddCodeLine("1", @"Dictionary<string, AClass2> dictTest2 = new Dictionary<string, AClass2>();");
            scripter.AddCodeLine("1", @"dictTest2.Add(""test"", new AClass2());");
            scripter.AddCodeLine("1", @"AClass2 Y = dictTest2[""test""];");
            scripter.AddCodeLine("1", @"Y.Hello();");

            scripter.AddCodeLine("1", @"Dictionary<string, AClass3> dictTest3 = new Dictionary<string, AClass3>();");
            scripter.AddCodeLine("1", @"dictTest3.Add(""test"", new AClass3());");
            scripter.AddCodeLine("1", @"AClass3 Z = dictTest3[""test""];");
            scripter.AddCodeLine("1", @"Z.Hello();");

            scripter.Run(RunMode.Run);

            foreach (ScriptError err in scripter.Error_List)
            {
                Console.WriteLine(string.Format("Error: {0}. Line {1}/{2}:\n {3}",
                err.Message,
                err.LineNumber,
                err.PCodeLineNumber,
                err.Line));
            }

            Console.WriteLine("Press any key...");
            Console.ReadKey();
        }
    }
}
