using System;

public abstract class Shape
{
    public abstract void DrawYourself();
}

public class Triangle : Shape
{
    public override void DrawYourself()
    {
        Console.WriteLine("         *     ");
        Console.WriteLine("        * *    ");
        Console.WriteLine("       *   *   ");
        Console.WriteLine("      *     *  ");
        Console.WriteLine("     *_______* ");
    }
}

public class Circle : Shape
{   
    public override void DrawYourself()
    {
        Console.WriteLine("        ***     ");
        Console.WriteLine("     *       *  ");
        Console.WriteLine("    *         * ");
        Console.WriteLine("    *         * ");
        Console.WriteLine("     *       *  ");
        Console.WriteLine("        ***     ");
    }
}

public class Rectangle : Shape
{
    public override void DrawYourself()
    {
        Console.WriteLine(" ------------------ ");
        Console.WriteLine("|__________________|");
    }
}


class ShapeTester
{
    public static void Main()
    {
        Shape myShape;
        myShape = new Circle();
        myShape.DrawYourself();
        myShape = new Triangle();
        myShape.DrawYourself();
        myShape = new Rectangle();
        myShape.DrawYourself();
    }
}

