using System;

public delegate void MenuHandler(object sender, EventArgs e);

public class MenuItem
{
	string text;
	int num;

	public event MenuHandler MH;

	private MenuHandler mh = null;

	public event MenuHandler MenuSelection
	{
		add
		{
			mh += value;
			num++;
		}
		remove
		{
			mh -= value;
			num--;
		}
	}

	public MenuItem(string text)
	{
		this.text = text;
		num = 0;
	}

	public void Fire1()
	{
		if (mh != null)
		{
			mh(this, null);
		}
	}

	public void Fire2()
	{
		if (MH != null)
		{
			MH(this, null);
		}
	}

	public int Num
	{
		get
		{
			return num;
		}
	}

}

public class TestEvents
{
	public static void StaticProc(object sender, EventArgs e)
	{
		Console.WriteLine("invoke a static method");
	}

	public void Proc(object sender, EventArgs e)
	{
		Console.WriteLine("invoke a method");
	}

	public static void Main()
	{
		MenuItem m = new MenuItem("abc");

		m.MenuSelection += new MenuHandler(StaticProc);
		m.Fire1();

		TestEvents t = new TestEvents();
		m.MH += new MenuHandler(t.Proc);
		m.Fire2();
	}
}

