using System;

class TimeSpan
{
	private uint totalSeconds;

	public TimeSpan(uint initialTotalSeconds)
	{
		totalSeconds = initialTotalSeconds;
	}

	public uint TotalSeconds
	{
		get
		{
			return totalSeconds;
		}
	}

	public static explicit operator ushort(TimeSpan convertFrom)
	{
		Console.WriteLine("Converting from TimeSpan to ushort");
		return (ushort)convertFrom.TotalSeconds;
	}

	public static explicit operator TimeSpan(uint convertFrom)
	{
		Console.WriteLine("Converting from uint to TimeSpan");
		return new TimeSpan(convertFrom);
	}

}

class ExplicitConversionTester
{
	public static void Main()
	{
		ushort simpleTimeSeconds;
		TimeSpan myTime = new TimeSpan(130);

		simpleTimeSeconds = (ushort) myTime;
		Console.WriteLine("Value of simpleTimeSeconds: {0}", simpleTimeSeconds);

		myTime = (TimeSpan) 200;
		Console.WriteLine("Value of myTime: {0}", myTime.TotalSeconds);
	}
}