using System;
public class TestInterfaces
{
	public interface IMyIntf1
	{
		void Proc1(int x);
		int Prop1 {get; set;}
	}

	public interface IMyIntf2: IMyIntf1
	{
		int Proc2(int x);
	}

	public interface IMyIntf3
	{
		string Proc3();
	}

	public class MyClass: IMyIntf2, IMyIntf3
	{
		int x;

		public void Proc1(int x)
		{
			println "Proc1";
			this.x = x;
		}

		public int Proc2(int x)
		{
			println "Proc2";
			return x + x;
		}

		string IMyIntf3.Proc3()
		{
			println "Proc3";
			return "Hello";
		}

		public int Prop1
		{
			get
			{
				return x;
			}
			set
			{
				x = value;
			}
		}
	}

	public static void Main()
	{
		MyClass p = new MyClass();
		Test(p);
	}

	public static void Test(IMyIntf1 i)
	{
		i.Proc1(10);
		println i.Prop1;

		MyClass x;
		if (i is MyClass)
		{
			x = (MyClass) i;
			x.Proc3();
		}

		x = i as MyClass;
		if (x != null)
			x.Proc3();
	}
}


